<?php
/** 
*
* @package ucp
* @version $Id: ucp_invit.php  $
* @copyright (c) 2008 ksar
* @license http://opensource.org/licenses/gpl-license.php GNU Public License 
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

/**
* ucp_activate
* User activation
* @package ucp
*/
class ucp_invit
{
	var $u_action;

	function main($id, $mode)
	{
		global $config, $phpbb_root_path, $phpEx;
		global $db, $user, $auth, $template;

		$submit		= (!empty($_POST['submit'])) ? true : false;
		
		if (!$auth->acl_get('u_invit')){
			trigger_error($user->lang['UCP_INVIT_NOTAC']);
		}
		
		switch ($mode){
		
			case 'stats':
			
				$sql = 'SELECT *
						FROM ' . INVIT_TABLE . "
						WHERE user_id=".$user->data['user_id'];

				$result = $db->sql_query($sql);
				
				$i = 0;
				while ($row = $db->sql_fetchrow($result))
				{
					if ($row['activ_id'] != '0'){
						$sql_user = 'SELECT user_id, username, user_colour
							FROM ' . USERS_TABLE . "
							WHERE user_id = '" . $row['activ_id']. "'";
						$result_user = $db->sql_query($sql_user);
						$user_ok = $db->sql_fetchrow($result_user);
						$filleul = get_username_string('full', $user_ok['user_id'], $user_ok['username'], $user_ok['user_colour']);
						$db->sql_freeresult($result_user);
					}else{
						$filleul = false;
					}
					$template->assign_block_vars('invit', array(
						'S_INVIT'			=> $row['invit_id'],
						'S_DATE'			=> $user->format_date($row['crea_time']),
						'S_EMAIL'			=> $row['mail'],
						'S_FILLEUL'			=> ($filleul) ? true : false,
						'S_REG_DATE'		=> ($filleul) ? $user->format_date($row['activ_time']) : 0,
						'S_FILLEUL_ID'		=> ($filleul) ? $filleul : 0,
						'S_ROW_COUNT'		=> $i,
					));
					
					$i++;
				}
				
				if ($i == 0){
					$template->assign_vars( array(
						'S_NO_INVIT'		=> true,
					));
				}
				
				$this->page_title = 'UCP_INVIT_STATS';
				$this->tpl_name = 'ucp_invit_stats';
			
			break;
		
			case 'invit':
			default:
				if ($submit){
				
					$email = strtolower(request_var('email', '',true));
					$text = request_var('message', '');
					
					if (!$email){
						$error[] = $user->lang['UCP_INVIT_NO_EMA'];
					}
					
					if (!sizeof($error))
					{
						$server_url = generate_board_url();
						$user_actkey = gen_rand_string(20);
						$activation_link = "$server_url/ucp.$phpEx?mode=register&par=$user_actkey";
						
						$sql = 'INSERT INTO ' . INVIT_TABLE . ' ' . $db->sql_build_array('INSERT', array(
							'user_id'		=> $user->data['user_id'],
							'mail'			=> (string) $email,
							'activ_key'		=> $user_actkey,
							'activ'			=> 1,
							'crea_time'			=> time())
						);
						$db->sql_query($sql);
						
						include_once($phpbb_root_path . 'includes/functions_messenger.' . $phpEx);

						$messenger = new messenger(false);

						$messenger->template('ucp_invit', $data['lang']);

						$messenger->to($email);

						$messenger->headers('X-AntiAbuse: Board servername - ' . $config['server_name']);
						$messenger->headers('X-AntiAbuse: User_id - ' . $user->data['user_id']);
						$messenger->headers('X-AntiAbuse: Username - ' . $user->data['username']);
						$messenger->headers('X-AntiAbuse: User IP - ' . $user->ip);

						$messenger->assign_vars(array(
							'USERNAME'		=> $user->data['username'],
							'MESSAGE'		=> htmlspecialchars_decode($text),
							'U_ACTIVATE'	=> $activation_link)
						);

						$messenger->send(NOTIFY_EMAIL);
					
						$meta_info = append_sid("{$phpbb_root_path}ucp.$phpEx", "i=$id");
						$message = $user->lang['UCP_INVIT_ENVOY'];

						meta_refresh(3, $meta_info);
						$message .= '<br /><br />' . sprintf($user->lang['RETURN_UCP'], '<a href="' . $meta_info . '">', '</a>');
						trigger_error($message);
					}
				
				}
				$last_month = time() - 3600 * 24 * 30;
				$sql = 'SELECT COUNT(invit_id) AS invit
						FROM ' . INVIT_TABLE . "
						WHERE crea_time > $last_month AND user_id=".$user->data['user_id'];

				$result = $db->sql_query($sql);
				$nb_invit = (int) $db->sql_fetchfield('invit');
				$db->sql_freeresult($result);
					
				if (($nb_invit >= (int)$config['invite_number_month']) && ($config['invite_number_month'] != '0')){
					
					$meta_info = append_sid("{$phpbb_root_path}ucp.$phpEx", "i=$id");
					$message = $user->lang['UCP_INVIT_NOTAC'];
					
					$message .= '<br /><br />' . sprintf($user->lang['RETURN_UCP'], '<a href="' . $meta_info . '">', '</a>');
					trigger_error($message);
				}
					
				$this->page_title = 'UCP_INVIT';
					
				$template->assign_vars(array(
					'S_WARNING'				=> (sizeof($error)) ? true : false,
					'WARNING_MSG'			=> (sizeof($error)) ? implode('<br />', $error) : '',
					'S_MAX_INVIT'			=> ($config['invite_number_month'] == '0') ? $user->lang['UCP_INVIT_ILLI'] : $config['invite_number_month'],
					'S_SEND_INVIT'			=> $nb_invit,
					'S_UCP_ACTION'			=> $this->u_action)
				);
					
				$this->tpl_name = 'ucp_invit';
			break;
		}
	}
}

?>